/*
 * Implementacio de les operacions sobre FST
 */

#include <assert.h>
#include <stdio.h>
#include "fst.h"

/* Implementacio de les operacions */

FST ObrirFST(ModeFST m, const char *nom)
{
    FST f;

    if (m == lectura) {
        f = (FST)fopen(nom, "r");
    } else if (m == escriptura) {
        f = (FST)fopen(nom, "w");
    } else assert(0);
    assert(f != NULL);
    return f;
}

void LlegirEnterFST(FST f, int *const e)
{
    int	ret;

    ret = fscanf((FILE *)f, "%d", e);
    assert(feof((FILE *)f) || (ret == 1 && !ferror((FILE *)f)));
}

void LlegirRealFST(FST f, float *const r)
{
    int	ret;

    ret = fscanf((FILE *)f, "%f", r);
    assert(feof((FILE *)f) || (ret == 1 && !ferror((FILE *)f)));
}

void LlegirCaracterFST(FST f, char *const c)
{
    *c = fgetc((FILE *)f);
    assert(feof((FILE *)f) || !ferror((FILE *)f));
}

void EscriureEnterFST(FST f, int e)
{
    int	ret;

    ret = fprintf((FILE *)f, "%d", e);
    assert(ret >= 0 && !ferror((FILE *)f));
}

void EscriureRealFST(FST f, float r)
{
    int	ret;

    ret = fprintf((FILE *)f, "%g", r);
    assert(ret >= 0 && !ferror((FILE *)f));
}

void EscriureCaracterFST(FST f, char c)
{
    char	ret;

    ret = fputc(c, (FILE *)f );
    assert(ret == c && !ferror((FILE *)f));
}

int FdFST(FST f)
{
    return feof((FILE *)f);
}

void TancarFST(FST f)
{
    int	ret;

    ret = fclose((FILE *)f);
    assert(ret == 0);
}
